from tlc.core.url import Scheme as Scheme, Url as Url
from tlc.core.url_adapter import UrlAdapterAsyncFromSync as UrlAdapterAsyncFromSync, UrlAdapterDirEntry as UrlAdapterDirEntry
from tlc.core.url_adapter_registry import UrlAdapterRegistry as UrlAdapterRegistry
from typing import Iterator

class HttpUrlAdapter(UrlAdapterAsyncFromSync):
    """
    An adapter for resolving reads/writes to URLs starting with `http://` or `https://`
    """
    def schemes(self) -> list[Scheme]: ...
    def read_string_content_from_url(self, url: Url) -> str: ...
    def read_binary_content_from_url(self, url: Url) -> bytes: ...
    def delete_url(self, url: Url) -> None: ...
    def make_dirs(self, url: Url, exist_ok: bool = False) -> None: ...
    def get_file_size(self, url: Url) -> int: ...
    def list_dir(self, url: Url) -> Iterator[UrlAdapterDirEntry]: ...
    def exists(self, url: Url) -> bool: ...
    def is_dir(self, url: Url) -> bool: ...
    def is_writable(self, url: Url) -> bool: ...
